# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: unacast/v2/geography/geography_service.proto
# plugin: python-betterproto
from dataclasses import dataclass
from typing import (
    TYPE_CHECKING,
    Dict,
    Optional,
)

import betterproto
import grpclib
from betterproto.grpc.grpclib_server import ServiceBase


if TYPE_CHECKING:
    import grpclib.server
    from betterproto.grpc.grpclib_client import MetadataLike
    from grpclib.metadata import Deadline


@dataclass(eq=False, repr=False)
class GetTopoJsonRequest(betterproto.Message):
    catalog_id: str = betterproto.string_field(1)
    billing_context: str = betterproto.string_field(2)
    """Requestee might not have access to all map-data"""

    map_layer_id: str = betterproto.string_field(3)
    """
    Which map_layer to search - only allowing one; too complex to derive and
    make separations in the response, and no real usecase for combined
    map_layers
    """

    polygon_bound: "BoundingBox" = betterproto.message_field(8)
    """
    only features with geometriess intersecting with the area defined by the
    bound is returned Passing an empty polygon (= all values set to 0 as
    `optional` is not supported), means no filter on geom
    """

    zoom_level: int = betterproto.int32_field(9)
    """
    This value indicates the zoom level of the map the features will be drawn
    on. Feature-geometries will be decimated using the DouglasPeucker-algorithm
    to reduce fidelity of geometries returned. Follows the zoom-level
    definition of MapBox (https://docs.mapbox.com/help/glossary/zoom-level/) If
    not set, API assumes a value of 6.
    """


@dataclass(eq=False, repr=False)
class BoundingBox(betterproto.Message):
    """
    BoundingBox describes a square geofence - ie the "display area" of a map.
    Values are lat/lon (degrees)
    """

    west: float = betterproto.double_field(1)
    north: float = betterproto.double_field(2)
    east: float = betterproto.double_field(3)
    south: float = betterproto.double_field(4)


@dataclass(eq=False, repr=False)
class GetTopoJsonResponse(betterproto.Message):
    topology: str = betterproto.string_field(1)
    """
    The resulting TopoJSON (https://github.com/topojson/topojson) as a string-
    blob The ID of the GeoJSON.Feature corresponds to the FeatureID of the
    Feature in the MapLayer. Also includes DisplayName in the attributes of the
    GeoJSON.Feature.
    """


class GeoServiceStub(betterproto.ServiceStub):
    async def get_topo_json(
        self,
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "GetTopoJsonResponse":
        return await self._unary_unary(
            "/unacast.v2.geography.GeoService/GetTopoJSON",
            get_topo_json_request,
            GetTopoJsonResponse,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )


class GeoServiceBase(ServiceBase):
    async def get_topo_json(self) -> "GetTopoJsonResponse":
        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def __rpc_get_topo_json(
        self, stream: "grpclib.server.Stream[GetTopoJsonRequest, GetTopoJsonResponse]"
    ) -> None:
        request = await stream.recv_message()
        response = await self.get_topo_json(request)
        await stream.send_message(response)

    def __mapping__(self) -> Dict[str, grpclib.const.Handler]:
        return {
            "/unacast.v2.geography.GeoService/GetTopoJSON": grpclib.const.Handler(
                self.__rpc_get_topo_json,
                grpclib.const.Cardinality.UNARY_UNARY,
                GetTopoJsonRequest,
                GetTopoJsonResponse,
            ),
        }
